#include "fastSimplex.hh"

int main() {
#if 1
  std::vector<std::string> variableNames;
  variableNames.push_back("x");
  variableNames.push_back("y");
  variableNames.push_back("delta1");
  variableNames.push_back("delta2");
  variableNames.push_back("delta3");

  
  FastSimplex simplex(variableNames, 2);
  {
    LinearForm<coefficient> l(variableNames);
    l.addMonomial(0, 1);
    l.addMonomial(1, 2);
    simplex.assignBasic(2, l);
  }
  {
    LinearForm<coefficient> l(variableNames);
    l.addMonomial(0, 1);
    l.addMonomial(1, -1);
    simplex.assignBasic(3, l);
  }
  {
    LinearForm<coefficient> l(variableNames);
    l.addMonomial(0, 1);
    l.addMonomial(1, -8);
    simplex.assignBasic(4, l);
  }

  //simplex.assertUpperBound(2, coordinate(4));
  simplex.assertUpperBound(2, -coordinate(coefficient(1)/2)); //UNSAT
  simplex.assertLowerBound(3, coordinate(1));
  simplex.assertUpperBound(4, coordinate(1));
  //std::cout << simplex;
  simplex.checkWellFormed();

  simplex.check();

  std::cout << simplex;
  simplex.checkWellFormed();
  simplex.printStatistics(std::cout);

#endif

#if 0
  WithInfinitesimal<double> x0(5);
  WithInfinitesimal<double> x1(0,1);

  std::cout << x0+x1 << std::endl;
#endif

#if 0
  WithMinusInfinity<coefficient> x(3);
  WithPlusInfinity<coefficient> y(5);
  std::cout << x << " " << y << " " << (x <= y) << std::endl;
#endif
  return 0;
}
